// defs.h -- common defines, types and prototypes for Dance

#include <windows.h>
#include <stdio.h>

#include <math.h>
#include <stdlib.h>

#define PI 3.14159265358979323846
#define boolean BOOL

#define MAXPATHLEN 128

#define COORD_X(x)	(x)
#define COORD_Y(y)	(draw_ht - (y))
#define COORD_DX(dx)	(dx)
#define COORD_DY(dy)	(-(dy))

/* File operations */
#define F_NONE		0
#define F_LOAD		1
#define F_SAVE		2
#define F_INSERT	3

#define F_SAVEAS        4

#define SQR(x)          ((x) * (x))
#define SGN(x)          ((x) < 0 ? (-1) : 1)
#ifndef ABS
#define ABS(x)          ((x) < 0 ? (-(x)) : (x))
#endif
#ifndef MIN
#define MIN(x,y)        ((x) < (y) ? (x) : (y))
#define MAX(x,y)        ((x) < (y) ? (y) : (x))
#endif

/* Types of mouse actions */
#define M_DOWN		0
#define M_UP		1
#define M_DRAG		2
#define M_HOLD		3
#define M_REDISPLAY	4



/* -------- Variables defined --------- */

/* misc.c */
char *xmalloc (int size);
char *xrealloc (char *ptr, int size);

/* file.c */
boolean file_command(char *file, int command);


/* newmain.c */
extern int draw_wid, draw_ht;

void new_main(void);
void redisplay_widgets(HWND);
int mass_radius(double m);
void review_system(void);

/* obj.h */

void init_objects(void);
void attach_fake_spring(int );
void kill_fake_spring(void);
void move_fake_mass(int , int );
int create_mass(void);
int create_spring(void);
void add_massparent(int , int );
void del_massparent(int , int );
void delete_spring(int );
void delete_mass(int );
void delete_selected(void);
void delete_all(void);
void reconnect_masses(void);
void restore_state(void);
void save_state(void);
int nearest_object(int , int , boolean *);
void eval_selection(void);
boolean anything_selected(void);
void select_object(int , boolean , boolean );
void select_objects(int , int , int , int , boolean );
void unselect_all(void);
void select_all(void);
void duplicate_selected(void);
void translate_selobj(int , int );
void changevel_selobj(int , int , boolean );
void tempfixed_obj(boolean );
void set_sel_restlen(void);
void set_center(void);

/* phys.c
 */
boolean animate_obj(void);

