#define TGA_NEWTYPE        0x00
#define TGA_OLDTYPE         0x01

#define TGA_BOTTOMLEFT   0x00
#define TGA_BOTTOMRIGHT 0x01
#define TGA_TOPLEFT          0x02
#define TGA_TOPRIGHT        0x03

typedef struct
{
	unsigned __int8 IDLen;
	unsigned __int8 ColorMapType;
	unsigned __int8 ImageType;
	unsigned __int8 ColorMapSpec[5];
	unsigned __int8 ImageSpec[10];
}	TGA_Header;

typedef struct
{
	unsigned __int16 ExtensionSize;
	char AuthorName[41];
	char AuthorComments[324];
	unsigned __int16 DateTime[6];
	char JobName[41];
	unsigned __int16 JobTime[3];
	unsigned __int32 KeyColor;
	unsigned __int16 PixelAspectRatio[2];
	unsigned __int16 GammaValue[2];
	unsigned __int32 ColorCorrectionOffset;
	unsigned __int32 PostageStampOffset;
	unsigned __int32 ScanLineOffset;
	unsigned __int8 AttributesType;
} TGA_ExtensionArea;

typedef unsigned __int16 TGA_ColorCorrectionTable[1024];

typedef struct
{
	unsigned __int32 ExtensionAreaOffset;
	unsigned __int32 DeveloperDirectoryOffset;
	char Signature;
} TGA_Footer;

